#include <cmath>
#include <iostream>
#include <fstream>
#include <string>
#include <cstdlib>
#include <iomanip>
using namespace std;

int main()
{
    double R = 0.000001;//spherical cell radius
    double a = 1; //integrin radius
    double theta[500];
    double phi[500];
    double force[500];
    double Ecell;
	double Ematrix;

    ifstream getE;
    {
		//opens the file
		getE.open("elasticmoduli.txt");

		//makes sure that the file opened properly
		while(getE.fail())
		{
			cout << "Error opening file" << endl;
			exit(1);
		}

		//extracts data from the file
		while(!getE.eof())
		{
			getE >> Ecell >> Ematrix;
		}

		//close file
		getE.close();

		//outputs data to the screen


       cout << "Ecell = " << Ecell<< endl << "Ematrix = "<< Ematrix << endl;
		// cout is equivelant to printf in C

	}

    double Vcell = 0.04;
    double Vmatrix = 0.02;
    double Eprime = (1/(((1-pow(Vcell, 2.0))/Ecell)+((1-pow(Vmatrix, 2.0))/Ematrix)));
	double strain = 10000; //can take in values from an external strain profile - strains vary every second - cannot go below this timescale
    double pi = 3.1416;


	ifstream gettheta;
	ifstream getphi;
	{
		//opens the file
		gettheta.open("theta.txt");

		//makes sure that the file opened properly
		while(gettheta.fail())
		{
			cout << "Error opening file" << endl;
			exit(1);
		}

		int n = 0;
		//extracts data from the file
		while(!gettheta.eof())
		{
			gettheta >> theta[n];
			n++;
		}

		//close file
		gettheta.close();

		//outputs data to the screen
		for(int i = 0; i<500; i++)
		{
		  //  cout << theta[i] << endl;
		}

	}

	{
		//opens the file
		getphi.open("phi.txt");

		//makes sure that the file opened properly
		while(getphi.fail())
		{
			cout << "Error opening file" << endl;
			exit(1);
		}

		 int n = 0;
		//extracts data from the file
		while(!getphi.eof())
		{
			getphi >> phi[n];
			n++;
		}

		//close file
		getphi.close();

		//outputs data to the screen
		for(int i=0;i<500;i++)
		{
		   // cout <<"phi" << phi[i] << endl;
		}

	}

    for(int i=0;i<500;i++)
    {
    force[i] = ((15*Eprime*(1-pow(Vmatrix, 2.0))) / (2*Ematrix*(7-5*(Vmatrix))))*strain*pi*a*R*sin(theta[i])*sin(theta[i])*sin((2*phi[i]));
    }
    for(int j=0;j<500;j++)
    {
        //cout<<"force = "<<force[j]<<endl;
    }

    ofstream outputforce ("force.txt");

  if (outputforce.is_open())
  {
	  cout << "Updating Force Values.../" << endl;

      for(int j=0;j<500;j++)
    {
        outputforce<<fixed<<setprecision(6)<<abs(force[j])<<endl;
    }
    outputforce.close();
  }
  else cout << "Unable to open file";

  return 0;
}
